MDWParser Class Reference

the main class to read a MindWrite file More...

`#include <MDWParser.hxx>`

Inheritance diagram for MDWParser:

## Public Member Functions

| MDWParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~MDWParser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (WPXDocumentInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
void | setVersion (int vers)
| sets the works version More...

## Protected Member Functions

void | init ()
| inits all internal variables More...
void | createDocument (WPXDocumentInterface *documentInterface)
| creates the listener which will be associated to the document More...
bool | createZones ()
| finds the different objects zones More...
bool | sendZone (int i)
| try to send a zone More...
bool | readGraphic (MDWParserInternal::LineInfo const &line)
| try to read a graphic More...
bool | readRuler (MDWParserInternal::LineInfo &line)
| try to read a ruler More...
bool | readCompressedText (MDWParserInternal::LineInfo const &line)
| try to read a compressed text zone More...
bool | readText (MDWParserInternal::LineInfo const &line)
| try to read a non compressed text zone More...
void | sendText (std::string const &text, std::vector< MWAWFont > const &fonts, std::vector< int > const &textPos)
| try to send the text More...
void | sendHeaderFooter (bool header)
| try to send the header/footer zone More...
void | sendHeaderFooterFields (bool header)
| try to send the header/footer fields as text (in a textbox) More...
bool | readFonts (MWAWEntry const &entry, std::vector< MWAWFont > &fonts, std::vector< int > &textPos)
| try to read the fonts More...
bool | readPrintInfo (MWAWEntry &entry)
| read the print info zone More...
bool | readLinesInfo (MWAWEntry &entry)
| read the lines information zone More...
bool | readLastZone (MWAWEntry &entry)
| read the last zone ( pos + 7fffffff ) More...
bool | readZone8 (MWAWEntry &entry)
| read the 8th zone ( unknown zone) More...
bool | readHeadingStates (MWAWEntry &entry)
| read the heading state More...
bool | readHeadingFields (MWAWEntry &entry)
| read the heading field zone ( zone 12 ) More...
bool | readHeadingProperties (MWAWEntry &entry)
| read the heading property zone More...
bool | readHeadingCustom (MWAWEntry &entry)
| read the heading custom zone More...
void | setProperty (MWAWParagraph const &para)
| sends a paragraph property to the listener More...
void | newPage (int number)
| adds a new page More...
MWAWEntry | readEntry ()
| read a file entry More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWContentListenerPtr & | getListener ()
| returns the listener More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
void | setListener (MWAWContentListenerPtr &listener)
| sets the listener More...
void | resetListener ()
| resets the listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
void | setFontConverter (MWAWFontConverterPtr fontConverter)
| sets the font convertor More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes

shared_ptr < MDWParserInternal::State > | m_state
| the state More...

## Friends

class | MDWParserInternal::SubDocument

## Detailed Description

the main class to read a MindWrite file

## Constructor & Destructor Documentation

MDWParser::MDWParser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

MDWParser::~MDWParser | ( |  | ) |

virtual

destructor

## Member Function Documentation

bool MDWParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |

virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

void MDWParser::createDocument | ( | WPXDocumentInterface * | documentInterface | ) |

protected

creates the listener which will be associated to the document

Referenced by parse().

bool MDWParser::createZones | ( |  | ) |

protected

finds the different objects zones

Referenced by parse().

void MDWParser::init | ( |  | ) |

protected

inits all internal variables

Referenced by MDWParser().

void MDWParser::newPage | ( | int | number | ) |

protected

adds a new page

Referenced by sendZone().

void MDWParser::parse | ( | WPXDocumentInterface * | documentInterface | ) |

virtual

virtual function used to parse the input

Implements MWAWParser.

bool MDWParser::readCompressedText | ( | MDWParserInternal::LineInfo const & | line | ) |

protected

try to read a compressed text zone

Referenced by sendZone().

MWAWEntry MDWParser::readEntry | ( |  | ) |

protected

read a file entry

Referenced by createZones().

bool MDWParser::readFonts | ( | MWAWEntry const & | entry,
|  | std::vector< MWAWFont > & | fonts,
|  | std::vector< int > & | textPos
| ) |  |

protected

try to read the fonts

Referenced by readCompressedText(), and readText().

bool MDWParser::readGraphic | ( | MDWParserInternal::LineInfo const & | line | ) |

protected

try to read a graphic

Referenced by sendZone().

bool MDWParser::readHeadingCustom | ( | MWAWEntry & | entry | ) |

protected

read the heading custom zone

Referenced by createZones().

bool MDWParser::readHeadingFields | ( | MWAWEntry & | entry | ) |

protected

read the heading field zone ( zone 12 )

Referenced by createZones().

bool MDWParser::readHeadingProperties | ( | MWAWEntry & | entry | ) |

protected

read the heading property zone

Referenced by createZones().

bool MDWParser::readHeadingStates | ( | MWAWEntry & | entry | ) |

protected

read the heading state

Referenced by createZones().

bool MDWParser::readLastZone | ( | MWAWEntry & | entry | ) |

protected

read the last zone ( pos + 7fffffff )

Referenced by createZones().

bool MDWParser::readLinesInfo | ( | MWAWEntry & | entry | ) |

protected

read the lines information zone

01[45]0

Referenced by createZones().

bool MDWParser::readPrintInfo | ( | MWAWEntry & | entry | ) |

protected

read the print info zone

Referenced by createZones().

bool MDWParser::readRuler | ( | MDWParserInternal::LineInfo & | line | ) |

protected

try to read a ruler

Referenced by readLinesInfo().

bool MDWParser::readText | ( | MDWParserInternal::LineInfo const & | line | ) |

protected

try to read a non compressed text zone

Referenced by sendZone().

bool MDWParser::readZone8 | ( | MWAWEntry & | entry | ) |

protected

read the 8th zone ( unknown zone)

Referenced by createZones().

void MDWParser::sendHeaderFooter | ( | bool | header | ) |

protected

try to send the header/footer zone

field are separated from the main text -> we need to use an intermediate frame

Referenced by MDWParserInternal::SubDocument::parse().

void MDWParser::sendHeaderFooterFields | ( | bool | header | ) |

protected

try to send the header/footer fields as text (in a textbox)

Referenced by MDWParserInternal::SubDocument::parse().

void MDWParser::sendText | ( | std::string const & | text,
|  | std::vector< MWAWFont > const & | fonts,
|  | std::vector< int > const & | textPos
| ) |  |

protected

try to send the text

Referenced by readCompressedText(), and readText().

bool MDWParser::sendZone | ( | int | i | ) |

protected

try to send a zone

Referenced by parse(), and sendHeaderFooter().

void MDWParser::setProperty | ( | MWAWParagraph const & | para | ) |

protected

sends a paragraph property to the listener

Referenced by sendZone().

## Friends And Related Function Documentation

friend class MDWParserInternal::SubDocument

friend

## Member Data Documentation

shared_ptr<MDWParserInternal::State> MDWParser::m_state

protected

the state

Referenced by checkHeader(), createDocument(), createZones(), init(), newPage(), parse(), readCompressedText(), readHeadingCustom(), readHeadingFields(), readHeadingProperties(), readLinesInfo(), readZone8(), sendHeaderFooter(), sendHeaderFooterFields(), and sendZone().

The documentation for this class was generated from the following files:

- MDWParser.hxx
- MDWParser.cxx